<?php if ( ! defined( 'ABSPATH' ) ) { die; } // Cannot access pages directly.

/* Custom */
add_action( 'admin_enqueue_scripts', 'codevz_fields_enqueue' );
function codevz_fields_enqueue() {
  wp_enqueue_script( 'cz-fields', CSF_PLUGIN_URL . '/fields/codevz_fields/codevz_fields.js', array( 'jquery' ), '', false );
  wp_enqueue_style( 'cz-fields', CSF_PLUGIN_URL . '/fields/codevz_fields/codevz_fields.css' );

  wp_enqueue_script( 'cz-dtpicker', CSF_PLUGIN_URL . '/fields/codevz_fields/jquery.simple-dtpicker.js', array( 'jquery' ), '', false );
  wp_enqueue_style( 'cz-dtpicker', CSF_PLUGIN_URL . '/fields/codevz_fields/jquery.simple-dtpicker.css' );
}

/* Field: Slider */
if( ! class_exists( 'CSF_Field_slider' ) ) {
  class CSF_Field_slider extends CSF_Fields {

    public function __construct( $field, $value = '', $unique = '', $where = '' ) {
      parent::__construct( $field, $value, $unique, $where );
    }

    public function output(){

      if ( isset( $this->field['options'] ) ) {
        $options = $this->field['options'];
      } else {
        $options = array( 'step' => 1, 'unit' => 'px', 'min' => 0, 'max' => 100 );
      }

      echo '<input type="'. esc_attr( $this->element_type() ) .'" name="'. esc_attr( $this->element_name() ) .'" value="'. $this->element_value() .'"'. $this->element_class() . $this->element_attributes() .'/>';
      echo '<div class="csf-slider" data-options=\'' . json_encode( $options ) . '\'></div>';
      
      $this->element_after();

    }

  }
}

if( ! class_exists( 'CSF_Field_autocomplete' ) ) {
  class CSF_Field_autocomplete extends CSF_Fields {

    public function __construct( $field, $value = '', $unique = '' ) {
      parent::__construct( $field, $value, $unique );
    }

    public function output() {

      $value = $this->element_value();
      $query = $values = '';

      if ( isset( $this->field['query_args'] ) ) {
        $query = json_encode(array(
          'action'    => 'codevz_autocomplete', 
          'query_args'  => $this->field['query_args'],
          'elm_name'    => $this->element_name()
        ));
      }

      if ( ! empty( $value ) ) {
        if ( is_array( $value ) ) {
          foreach ( $value as $id ) {
            $values .= empty( $id ) ? '' : '<div id="' . esc_attr( $id ) . '"><input name="' . esc_attr( $this->element_name() ) . '[]" value="' . esc_attr( $id ) . '" /><span> ' . esc_html( get_the_title( $id ) ) . '<i class="fa fa-remove"></i></span></div>';
          }
        } else {
          $values .= '<div id="' . esc_attr( $value ) . '"><input name="' . esc_attr( $this->element_name() ) . '" value="' . esc_attr( $value ) . '" /><span> ' . esc_html( get_the_title( $value ) ) . '<i class="fa fa-remove"></i></span></div>';
        }
      }

      echo '<div class="cs-autocomplete" data-query=\'' . $query . '\'>';
      echo '<input type="text"'. $this->element_class() . $this->element_attributes() .' />';
      echo '<i class="fa fa-codevz"></i>';
      echo '<div class="ajax_items"></div>';
      echo '<div class="selected_items">' . do_shortcode( $values ) . '</div>';
      echo '</div>';

      $this->element_after();

    }

  }

  add_action( 'wp_ajax_codevz_autocomplete', 'codevz_autocomplete' );
  function codevz_autocomplete() {

    if ( empty( $_GET['query_args'] ) || empty( $_GET['s'] ) ) {
      echo '<b>' . esc_html__( 'Query is empty ...', 'remix' ) . '</b>';
      die();
    }

    $out = array();
    ob_start();

    $query = new WP_Query( wp_parse_args( $_GET['query_args'], array( 's' => $_GET['s'] ) ) );
    if ( $query->have_posts() ) {
      while ( $query->have_posts() ) {
        $query->the_post();
        echo '<div data-id="' . get_the_ID() . '">' . get_the_title() . '</div>';
      }
    } else {
      echo '<b>' . esc_html__( 'Not found', 'remix' ) . '</b>';
    }

    echo ob_get_clean();
    wp_reset_postdata();
    die();
  }
}

if( ! class_exists( 'CSF_Field_DateTimePicker' ) ) {
  class CSF_Field_DateTimePicker extends CSF_Fields {

    public function __construct( $field, $value = '', $unique = '' ) {
      parent::__construct( $field, $value, $unique );
    }

    public function output(){

      echo '<input class="datetimepicker" type="'. esc_attr( $this->element_type() ) .'" name="'. esc_attr( $this->element_name() ) .'" value="'. esc_attr( $this->element_value() ) .'"'. $this->element_class() . $this->element_attributes() .'/>';
      
      $this->element_after();

    }

  }
}