<?php if ( ! defined( 'ABSPATH' ) ) { die; } // Cannot access pages directly.
/**
 *
 * Field: Icon
 *
 * @since 1.0.0
 * @version 1.0.0
 *
 */
if( ! class_exists( 'CSF_Field_icon' ) ) {
  class CSF_Field_icon extends CSF_Fields {

    public function __construct( $field, $value = '', $unique = '', $where = '' ) {
      parent::__construct( $field, $value, $unique, $where );
    }

    public function output() {

      $value  = $this->element_value();
      $hidden = ( empty( $value ) ) ? ' hidden' : '';

      echo '<div class="csf-icon-select">';
      echo '<span class="csf-icon-preview'. esc_attr( $hidden ) .'"><i class="'. esc_attr( $value ) .'"></i></span>';
      echo '<a href="#" class="button button-primary csf-icon-add">'. esc_html__( 'Add Icon', 'remix' ) .'</a>';
      echo '<a href="#" class="button csf-warning-primary csf-icon-remove'. esc_attr( $hidden ) .'">'. esc_html__( 'Remove Icon', 'remix' ) .'</a>';
      echo '<input type="text" name="'. esc_attr( $this->element_name() ) .'" value="'. esc_attr( $value ) .'"'. $this->element_class( 'csf-icon-value' ) . $this->element_attributes() .' />';
      echo '</div>';

      $this->element_after();

    }

  }
}
