<?php if ( ! defined( 'ABSPATH' ) ) { die; } // Cannot access pages directly.
/**
 *
 * Field: Upload
 *
 * @since 1.0.0
 * @version 1.0.0
 *
 */
if( ! class_exists( 'CSF_Field_upload' ) ) {
  class CSF_Field_upload extends CSF_Fields {

    public function __construct( $field, $value = '', $unique = '', $where = '' ) {
      parent::__construct( $field, $value, $unique, $where );
    }

    public function output() {

      $value = $this->element_value();

      $upload_type  = ( ! empty( $this->field['settings']['upload_type']  ) ) ? $this->field['settings']['upload_type']  : '';
      $button_title = ( ! empty( $this->field['settings']['button_title'] ) ) ? $this->field['settings']['button_title'] : esc_html__( 'Upload', 'remix' );
      $frame_title  = ( ! empty( $this->field['settings']['frame_title']  ) ) ? $this->field['settings']['frame_title']  : esc_html__( 'Upload', 'remix' );
      $insert_title = ( ! empty( $this->field['settings']['insert_title'] ) ) ? $this->field['settings']['insert_title'] : esc_html__( 'Use Image', 'remix' );

      if( ! empty( $this->field['preview'] ) ) {

        $exts   = array( 'jpg', 'gif', 'png', 'svg', 'jpeg' );
        $exp    = explode( '.', $value );
        $ext    = ( ! empty( $exp ) ) ? end( $exp ) : '';
        $image  = ( ! empty( $value ) && in_array( $ext, $exts ) ) ? $value : '';
        $hidden = ( empty( $value ) || ! in_array( $ext, $exts ) ) ? ' hidden' : '';

        echo '<div class="csf-image-preview'. esc_attr( $hidden ) .'">';
        echo '<div class="csf-image-inner"><i class="fa fa-times csf-image-remove"></i><img src="'. esc_url( $image ) .'" alt="' . esc_attr__( 'Preview', 'remix' ) . '" /></div>';
        echo '</div>';

      }

      echo '<div class="csf-table">';
      echo '<div class="csf-table-cell"><input type="text" name="'. esc_attr( $this->element_name() ) .'" value="'. esc_html( $value ) .'"'. $this->element_class() . $this->element_attributes() .'/></div>';
      echo '<div class="csf-table-cell"><a href="#" class="button csf-button" data-frame-title="'. esc_attr( $frame_title ) .'" data-upload-type="'. esc_attr( $upload_type ) .'" data-insert-title="'. esc_attr( $insert_title ) .'">'. esc_html( $button_title ) .'</a></div>';
      echo '</div>';

      $this->element_after();

    }
  }
}
